/*
 * Copyright (c) 2018 Goldman Sachs.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompany this distribution.
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 */

package org.eclipse.collections.api.factory.map.primitive;

import org.eclipse.collections.api.block.function.Function;
import org.eclipse.collections.api.block.function.primitive.BooleanFunction;
import org.eclipse.collections.api.map.primitive.MutableObjectBooleanMap;
import org.eclipse.collections.api.map.primitive.ObjectBooleanMap;

/**
 * A factory which creates instances of type {@link MutableObjectBooleanMap}.
 * This file was automatically generated from template file mutableObjectPrimitiveMapFactory.stg.
 *
 * @since 6.0.
 */
public interface MutableObjectBooleanMapFactory
{
    <K> MutableObjectBooleanMap<K> empty();

    /**
     * Same as {@link #empty()}.
     */
    <K> MutableObjectBooleanMap<K> of();

    /**
     * Same as {@link #empty()}.
     */
    <K> MutableObjectBooleanMap<K> with();

    /**
     * Same as {@link #empty()}. but takes in an initial capacity
     */
    <K> MutableObjectBooleanMap<K> ofInitialCapacity(int capacity);

    /**
     * Same as {@link #empty()}. but takes in an initial capacity
     */
    <K> MutableObjectBooleanMap<K> withInitialCapacity(int capacity);

    /**
     * Same as {@link #withAll(ObjectBooleanMap)}.
     */
    <K> MutableObjectBooleanMap<K> ofAll(ObjectBooleanMap<? extends K>  map);

    <K> MutableObjectBooleanMap<K> withAll(ObjectBooleanMap<? extends K>  map);

    /**
     * Creates an {@code MutableObjectBooleanMap} from an {@code Iterable<T>} by applying {@code keyFunction} and {@code valueFunction}.
     *
     * @since 10.0
     */
    <T, K> MutableObjectBooleanMap<K> from(Iterable<T> iterable, Function<? super T, ? extends K> keyFunction, BooleanFunction<? super T> valueFunction);
}
